<?php
add_action( 'admin_init', 'ilia_install' );
add_action( 'plugins_loaded', 'ilia_localization' );
add_action( 'admin_menu', 'ilia_plug_pages' );
add_action( 'network_admin_menu', 'ilia_plug_pages' );
function ilia_install() {
  $subject = "اطلاعات حساب شما در SITENAME";
  $message = "درود FULLNAME عزیز

مشخصات حساب کاربری شما به شرح زیر اعلام می گردد :

شناسه : USERNAME
پسورد : PASSWORD

جهت ورود به (LOGINURL) مراجعه فرمایید.
باتشکر
مدیریت SITENAME";
  if (!get_option('ilia_email_subject'))
    add_option('ilia_email_subject', $subject, '', 'no');
  if (!get_option('ilia_email_text'))
    add_option('ilia_email_text', $message, '', 'no');
  if (!get_option('ilia_source'))
    add_option('ilia_source', 'name', '', 'no');
}


function ilia_plug_pages() {
	add_submenu_page('bp-general-settings', ('ورود از شیرترونیکس'), ('ورود از شیرترونیکس'), 'edit_users', 'ilia-importer', 'ilia_page_output');
}

function ilia_get_profile_fields($all = false) {
  $file_path = ilia_file_path();

  $fh = @fopen($file_path, 'r');
  if ($fh) {

    $fields = fgetcsv($fh, 5120);

    fclose($fh);
    
    if ($all) {
      return $fields;
    } else {
      foreach ($fields as $field) {
        if ( $field != 'fullname' && $field != 'email' && $field != 'Profile Address' && $field != 'reg_date' )
          $profile_fields[] = $field;
      }
      return $profile_fields;
    }
    
	} else {
    return false;
  }
}

function ilia_get_csv_array() {
  $file_path = ilia_file_path();
  $titles = ilia_get_profile_fields(true);
  
  $fh = @fopen($file_path, 'r');
  if ($fh) {
    while (!feof($fh)) {
      $temp_fields = fgetcsv($fh, 5120);
      
      if (is_array($temp_fields)) {
        $new_fields = array();
        foreach ($temp_fields as $key => $value) {
          $new_fields[$titles[$key]] = $value;
        }
      }
      
      $fields[] = $new_fields;
    }


    fclose($fh);
    array_shift($fields);
    
    return $fields;
	} else {
    return false;
  }
}

function ilia_file_path($dir = false) {
  $target_path = wp_upload_dir();
  if ($dir)
    return trailingslashit($target_path['basedir']);
  else
    return trailingslashit($target_path['basedir']) . 'ilia-export.csv';
}

function ilia_process_import_queue() {
  @set_time_limit(60);
  $users = ilia_get_csv_array();
  
  $total = count($users);
  $count = get_option('ilia_count');
  $count = (!$count) ? 0 : $count;
  
  $imported_count = get_option('ilia_imported_count');
  $imported_count = (!$imported_count) ? 0 : $imported_count;
  
  $errors = get_option('ilia_errors');
  
  $users = array_slice($users, $count, 5);

  if (count($users)) {
    echo '<ul style="margin-left: 40px;">';
    foreach ($users as $user) {

      if (email_exists($user['email'])) {
        $errors[] = ('نادیده گرفته شد : ') . $user['email'];
        $count++;
        update_option('ilia_count', $count);
        continue;
      }
      
      $source = get_option('ilia_source');
      if ($source == 'email') {
        $temp_email = explode('@', $user['email']);
        $username = sanitize_user($temp_email[0], true);
      } else {
        $username = sanitize_user(trim(str_replace(' ', '', $user['username']), '.'), true);
      }

      $i = 0;
      $original_username = $username;
      while (username_exists($username)) {
        $i++;
        $username = $original_username . $i;
      }

      $joined_date = date('Y-m-d H:i:s', strtotime($user['reg_date']));

      $password = wp_generate_password();
  		$user_id = wp_insert_user(array(
        						"user_login"       => $username,
        						"display_name"     => $user['Name'],
        						"nickname"         => $user['Name'],
        						"user_pass"        => $password,
        						"user_email"       => $user['email'],
        						"user_registered"  => $joined_date,
        						"role"             => 'subscriber'
                    ));
      
  		if ( is_wp_error($user_id) ) {
  			$errors[] = ('ایجاد کاربر با خطا مواجه شد') . $user['Name'] . ' (' . $username . ')';
  		} else {
  			if (function_exists('bp_is_active')) {
  		    ilia_import_buddypress_fields($user_id, $user);
  		    
          ilia_fetch_ning_avatar( $user_id, $user['Profile Address'] );
        }

  			ilia_new_user_notification($user_id, $password);
        
        echo '<li style="font-size: 14px; display: block; height: 25px; line-height: 25px;">';
        echo bp_core_fetch_avatar( array('item_id' => $user_id, 'width' => 25, 'height' => 25) ) . ' ';
        echo sprintf('%s مشخصات کاربری %s ---- %s با موفقیت به بادی پرس منتقل شد.', $user['Name'], $username, $user['Email']) . '</li>';

        $imported_count++;
        update_option('ilia_imported_count', $imported_count);
  		}

      $count++;
      update_option('ilia_count', $count);
    }
    update_option('ilia_errors', $errors);
    
    echo "</ul>";
    echo '<h3>' . sprintf('در حال انتقال %s از %s کاربر ، لطفا تا اتمام انتقال منتظر بمانید', $count, $total) . '</h3>';

    ?>
    <br />
    <p>در صورتی که بصورتی خودکار به کاربر بعد منتقل نشدید دستی اقدام کنید <a class="button" href="admin.php?page=ilia-importer&action=process">کاربر بعدی</a></p>
  	<script type='text/javascript'>
  	<!--
  	function nextpage() {
  		//window.location.reload();
      window.location='admin.php?page=ilia-importer&action=process';
  	}
  	setTimeout( "nextpage()", 250 );
  	//-->
  	</script><?php
  	
  } else {
    echo '<h3>' . sprintf('سیستم موفق شد تعداد %d کاربر از مجموع %d کاربر را با موفقیت به بادی پرس منتقل نماید.', $imported_count, $total) . '</h3>';
    ?>
    <p>پسورد راندوم برای کاربران با موفقیت ایجاد و به آدرس ایمیلشان ارسال گردید.</p>
    <p>حال با کلیک بر روی دکمه "ساختار پروفایل کاربران" فیلدهای وارد شده را مرتب کنید و آنهایی را که نیازی ندارید حذف کنید</p>
    <p><a class="button" href="admin.php?page=bp-profile-setup">ساختار پروفایل کاربران</a></p>
    
    <?php
    if (is_array($errors) && count($errors)) {
      echo '<p>' . sprintf('تعداد %d کاربر به شرح زیر ایمیل یکسانی وارد کرده بودند و یا در بانک بادی پرس شما ایمیلشان وجود داشت که سیستم آنها را نادیده گرفت.', count($errors)) . '</p>';
      echo "<ul>";
      foreach ($errors as $error)
        echo '<li>'.$error.'</li>';
      echo "</ul>";
    }
    
    if (@unlink(ilia_file_path())) {
      delete_option('ilia_count');
      delete_option('ilia_imported_count');
      delete_option('ilia_errors');
    }

  }
}

function ilia_create_buddypress_fields() {
  $fields = ilia_get_profile_fields();

  foreach ($fields as $field) {
    if (xprofile_get_field_id_from_name($field))
			continue;

		$args = array(
			'field_group_id' => 1,
			'name' => $field,
			'type' => 'textarea',
			'is_required' => false
		);
    xprofile_insert_field( $args );
  }


}

function ilia_import_buddypress_fields($user_id, $user) {
  $fields = ilia_get_profile_fields();

  foreach ($fields as $field) {
    if ($user[$field])
      xprofile_set_field_data( $field, $user_id, $user[$field]);
  }
}

function ilia_filter_http_timeout( $val ) {
	return 30;
}

function ilia_filter_http_useragent( $user_agent ) {
	return 'Sharetronix To BuddyPress Importer: http://Aziran.ir';
}

function ilia_fetch_ning_avatar( $user_id, $profile_url ) {

  add_filter( 'http_request_timeout', 'ilia_filter_http_timeout' );
  add_filter( 'http_headers_useragent', 'ilia_filter_http_useragent' );
  
  $profile_page = wp_remote_retrieve_body(wp_remote_get($profile_url));
  if (!$profile_page)
    return false;

  $sub_html = trim(substr($profile_page, strpos($profile_page, 'class="module_user_thumbnail"', 2000) + 30, 200));
  $img_url = substr($sub_html, strpos($sub_html, 'src="http://api.3w.com/files/') + 5);
  $img_url = substr($img_url, 0, strpos($img_url, '?'));
  if (!$img_url)
    return false;
    
  $url = $img_url.'?width='.BP_AVATAR_FULL_WIDTH.'&height='.BP_AVATAR_FULL_HEIGHT.'&crop=1%3A1';
  
	$file_name = basename($img_url);

	$upload = wp_upload_dir();
	
	$upload['path'] = $upload['basedir'];

	$filename = wp_unique_filename( $upload['path'], $file_name );

	$new_file = $upload['path'] . "/$filename";
	if ( ! wp_mkdir_p( dirname( $new_file ) ) ) {
		$message = sprintf( 'سیستم قادر به ایجاد شاخه %s نیست . لطفا دسترسی ها را بررسی کنید.' , dirname( $new_file ) );
		return array( 'error' => $message );
	}

	$ifp = @ fopen( $new_file, 'wb' );
	if ( ! $ifp )
		return array( 'error' => sprintf(  'امکان ایجاد فایل %s وجود ندارد . لطفا دسترسی ها را بررسی کنید.' , $new_file ) );

	@fwrite( $ifp, $bits );
	fclose( $ifp );
	$stat = @ stat( dirname( $new_file ) );
	$perms = $stat['mode'] & 0007777;
	$perms = $perms & 0000666;
	@ chmod( $new_file, $perms );

	$headers = wp_get_http($url, $new_file);

	if ( ! $headers ) {
		@unlink($new_file);
		return new WP_Error( 'import_file_error', 'پاسخی از سرور دریافت نشد' );
	}

	if ( $headers['response'] != '200' ) {
		@unlink($new_file);
		return new WP_Error( 'import_file_error', sprintf('خطایی رخ داد %1$d %2$', $headers['response'], get_status_header_desc($headers['response']) ) );
	} else if ( isset($headers['content-length']) && filesize($new_file) != $headers['content-length'] ) {
		@unlink($new_file);
		return new WP_Error( 'import_file_error', 'سایز فایل مجاز نیست' );
	}
	
	if ( preg_match( '!\.(bin)$!i', $filename ) ) {
    if ( strpos($headers['content-type'], 'image/jpeg') !== false ) {
      $renamed = str_replace('.bin', '.jpg', $new_file);
      @rename($new_file, $renamed);
      $new_file = $renamed;
    } else if ( strpos($headers['content-type'], 'image/png') !== false ) {
      $renamed = str_replace('.bin', '.png', $new_file);
      @rename($new_file, $renamed);
      $new_file = $renamed;
    } else if ( strpos($headers['content-type'], 'image/gif') !== false ) {
      $renamed = str_replace('.bin', '.gif', $new_file);
      @rename($new_file, $renamed);
      $new_file = $renamed;
    } else {
      @unlink($new_file);
      return new WP_Error( 'import_file_error', 'پسوند صحیح نیست' );
    }
    $wp_filetype = wp_check_filetype( $filename );
  	if ( !$wp_filetype['ext'] ) {
      @unlink($new_file);
      return new WP_Error( 'import_file_error', 'پسوند صحیح نیست' );
    }
  }
  
  $avatar_folder_dir = apply_filters( 'bp_core_avatar_folder_dir', BP_AVATAR_UPLOAD_PATH . '/avatars/' . $user_id, $user_id, 'user', 'avatars' );

  require_once( ABSPATH . '/wp-admin/includes/image.php' );
	require_once( ABSPATH . '/wp-admin/includes/file.php' );

	bp_core_delete_existing_avatar( array( 'object' => 'user', 'avatar_path' => $avatar_folder_dir ) );

	$full_filename = wp_hash( $original_file . time() ) . '-bpfull.jpg';
	$thumb_filename = wp_hash( $original_file . time() ) . '-bpthumb.jpg';

  wp_mkdir_p( $avatar_folder_dir );

	$full_cropped = wp_crop_image( $new_file, 0, 0, BP_AVATAR_FULL_WIDTH, BP_AVATAR_FULL_HEIGHT, BP_AVATAR_FULL_WIDTH, BP_AVATAR_FULL_HEIGHT, false, $avatar_folder_dir . '/' . $full_filename );
	$thumb_cropped = wp_crop_image( $new_file, 0, 0, BP_AVATAR_FULL_WIDTH, BP_AVATAR_FULL_HEIGHT, BP_AVATAR_THUMB_WIDTH, BP_AVATAR_THUMB_HEIGHT, false, $avatar_folder_dir . '/' . $thumb_filename );

	@unlink( $new_file );

	return true;

}

function ilia_new_user_notification($user_id, $plaintext_pass) {
	$user = new WP_User($user_id);

	$user_login = stripslashes($user->user_login);
	$user_email = stripslashes($user->user_email);
	$blogname = wp_specialchars_decode(get_option('blogname'), ENT_QUOTES);

  $subject = stripslashes(get_option('ilia_email_subject'));
  $subject = str_replace('FULLNAME', $user->display_name, $subject);
	$subject = str_replace('USERNAME', $user_login, $subject);
	$subject = str_replace('EMAIL', $user_email, $subject);
	$subject = str_replace('SITENAME', $blogname, $subject);

  $message = stripslashes(get_option('ilia_email_text'));
  $message = str_replace('FULLNAME', $user->display_name, $message);
	$message = str_replace('USERNAME', $user_login, $message);
	$message = str_replace('PASSWORD', $plaintext_pass, $message);
	$message = str_replace('EMAIL', $user_email, $message);
	$message = str_replace('LOGINURL', wp_login_url(), $message);
	$message = str_replace('SITENAME', $blogname, $message);

	wp_mail($user_email, $subject, $message);

}

function ilia_page_output() {
	global $wpdb;

  if (bp_core_is_multisite() && !is_site_admin()) {
		echo "<p>:)</p>";
		return;
	}

	if(!current_user_can('edit_users')) {
		echo "<p>:)</p>";
		return;
	}

	echo '<div class="wrap">';
	
	switch( $_GET[ 'action' ] ) {
		default:

			$file_path = ilia_file_path();

			?>
			<h2>انتقال دهنده کاربران شیرترونیکس به بادی پرس</h2>
			<?php

      if (isset($_GET['del']) && file_exists($file_path)) {
        @unlink($file_path);
        echo '<div class="updated fade"><p>'. 'بانک با موفقیت از روی سرور حذف گردید.'.'</p></div>';
      }

			if (isset($_FILES['csv_file']['name'])) {
			
        wp_mkdir_p( ilia_file_path(true) );
        
        if ( preg_match( '!\.(csv)$!i', strtolower($_FILES['csv_file']['name']) ) ) {
        
          if (!move_uploaded_file($_FILES['csv_file']['tmp_name'], $file_path)) {
            @unlink($_FILES['csv_file']['tmp_name']);
            echo '<div class="error"><p>'.'خطایی در آپلود پیش آمد ، لطفا دسترسی ها را کنترل کنید'.'</p></div>';
          } else {
            delete_option('ilia_count');
            delete_option('ilia_imported_count');
            delete_option('ilia_errors');
          }

        } else {
          echo '<div class="error"><p>'.'شما می بایست بانکی با پسوند و ساختار csv آپلود کنید، لطفا فایل راهنما را مشاهده کنید.'.'</p></div>';
        }
        
      }

      if (file_exists($file_path)) {
        $fields = ilia_get_profile_fields();
        $total = count(ilia_get_csv_array());
        ?>
  			<form action="admin.php?page=ilia-importer&action=process" method="post">
  			<h3><?php echo sprintf('سیستم موفق شد تعداد %d کاربر را از بانک ورودی شما (مربوط به سیستم شیرترونیکس) شناسایی کند.', $total); ?></h3>
  			<p><a class="button" href="admin.php?page=ilia-importer&del=1">حذف بانک ورودی</a></p>

        <?php
        if (is_array($fields) && count($fields)) {
          ?>
    			<h3>شناسایی فیلد های پروفایل (مربوط به شیرترونیکس) :</h3>
    			<p>این فیلدها مربوط می شود به مواردی که کاربران شما در سیستم شیرترونیکس وارد کرده اند، میتواند در نسخه های مختلف شیرترونیکس متفاوت باشند.<br>شما بعد از ورود اطلاعات قادر خواهی بود هر یک از این موارد را به پروفایل کاربران بادی پرس خود اضافه کنید .</p>
    			<?php
          echo '<ul style="margin-left: 40px">';
          foreach ($fields as $field)
            echo '<li>'.$field.'</li>';
          echo "</ul>";
        }
        ?>
        
  			<h3>ساختار ایمیل آگاه سازی :</h3>
  			<p>
          <label for="email_subject">عنوان :</label><br />
          <input name="email_subject" value="<?php echo esc_attr(stripslashes(get_option('ilia_email_subject'))) ?>" size="100" /><br />
          <small>کدهای HTML قابل قبول نیست ، شما می توانید از تگهای : FULLNAME, USERNAME, EMAIL, SITENAME  در عنوان استفاده کنید.</small>
        </p>
  			<p>
          <label for="email_text">شرح ایمیل :</label><br />
          <textarea name="email_text" cols="100" rows="10"><?php echo esc_attr(stripslashes(get_option('ilia_email_text'))) ?></textarea><br />
          <small>کدهای HTML قابل قبول نیست ، شما می توانید از تگهای : FULLNAME, USERNAME, PASSWORD, EMAIL, LOGINURL, SITENAME در متن ایمیل استفاده کنید.</small>
  			</p>
  			
  			<h3>ساختار نام کاربری :</h3>
  			<p>
          <select name="source">
            <option value="name"<?php selected(get_option('ilia_source'), 'name') ?>>شناسه</option>
            <option value="email"<?php selected(get_option('ilia_source'), 'email') ?>>آدرس ایمیل</option>
          </select>
          <br />
          <small>برای ورود میتوانید نام کاربری و ایمیل کاربر را انتخاب کنید ، در ساختار بادی پرس تا ورژن 1.5 پیشنهاد میکنیم بر اساس شناسه را انتخاب کنید</small>
        </p>
  			
  			<br />
  			<p>بعد از کلیک بر روی دکمه انتقال کاربران سیستم شروع به انتقال کاربران خواهد کرد ، این کار در دسته های پنج تایی صورت خواهد گرفت و در پایان هر انتقال صفحه رفرش خواهد شد.لطفا تا پایان انتقال صبور باشید.</p>
  			<p class="submit">
  			  <input name="Submit" value="انتقال کاربران" type="submit">
  			</p>
  			</form>
        <p><small>توجه داشته باشید سیستم برای هر کاربر پسوردی بصورت راندوم در نظر می گیرد و به آدرس ایمیل شخص ارسال می کند ، ممکن است با توجه به ارسال گروهی ایمیل سرور کاربران ایمیل را به عنوان اسپم شناسایی کند ، به هر شکل که صلاح میدانید نسبت به اطلاع رسانی اقدام کنید. برای این موضوع راهکارهای زیادی وجود دارد، می توانید از تیم پشتیبانی ما کمک بگیرید.</small></p>
        <?php
        
      } else { 
      
  		  ?>
  			<form action="admin.php?page=ilia-importer" method="post" enctype="multipart/form-data">
  			<p><?php echo sprintf('لطفا به شکلی که در فایل راهنما توضیح داده شده از بانک کاربران شیرترونیکس خود پشتیبان بگیرید ( از تیبل Users و با پسوند CSV ) و از طریق فرم زیر آن را آپلود نمایید.<small><BR>اگر سایز بک آپ شما بیش از اندازه مجاز است ، میتوانید آن را از طریق FTP در مسیر  "%s" آپلود نمایید.<BR><font color="#FF0000">نکته مهم : دقت داشته باشید حتما فایل را به "ilia-export.csv" تغییر نام دهید.</font></small>', ilia_file_path(true)); ?></p>
  			<p>
  			  <input name="csv_file" id="csv_file" size="20" type="file" /><br />
  			  <small><?php echo ('بیشترین سایز مجاز برای آپلود : ') . ini_get('upload_max_filesize'); ?></small>
  			</p>
  			<p class="submit">
  			  <input name="Submit" value="آپلود بانک CSV &raquo;" type="submit">
  			</p>
  			</form>
        <?php
        
      } 
		break;
		
		case "process":
      if (isset($_POST['email_subject'])) {
        update_option('ilia_email_subject', strip_tags($_POST['email_subject']));
        update_option('ilia_email_text', strip_tags($_POST['email_text']));
        update_option('ilia_source', $_POST['source']);
        
        ilia_create_buddypress_fields();
      }

      ?>
			<h2>وارد کردن کاربران</h2>
			<br />
			<?php
      if (file_exists(ilia_file_path())) {
        ilia_process_import_queue();
      }
		break;

	}
	
	echo '</div>';
}
?>